/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package bioinformatics1;


/**
 *
 * @author caste
 */
public class AlphabetManager {
    private static Alphabet DNAAlphabet=generateDNAAlphabet();
    private static Alphabet RNAAlphabet=generateRNAAlphabet();
    private static Alphabet CodonAlphabet=generateCodonAlphabet();
    private static Alphabet ProteinAlphabet=generateProteinAlphabet();

    public static Alphabet alphabetForName(String name) {
        if(name.equals("DNA"))
            return DNAAlphabet;
        if(name.equals("RNA"))
            return RNAAlphabet;
        if(name.equals("Protein"))
            return ProteinAlphabet;
        if(name.equals("Codon"))
            return CodonAlphabet;
        return null;

    }

    private static Alphabet generateDNAAlphabet(){
        Alphabet alph=new SimpleAlphabet("DNA");
        Symbol a=new SimpleAtomicSymbol("A", "Adenine", alph);
        Symbol t=new SimpleAtomicSymbol("T", "Thymine", alph);
        Symbol c=new SimpleAtomicSymbol("C", "Cytosine", alph);
        Symbol g=new SimpleAtomicSymbol("G", "Guanine", alph);
        alph.addSymbol(a);
        alph.addSymbol(t);
        alph.addSymbol(c);
        alph.addSymbol(g);

        return alph;
    }

    private static Alphabet generateRNAAlphabet(){
        Alphabet alph=new SimpleAlphabet("Protein");
        Symbol a=new SimpleAtomicSymbol("A", "Adenine", alph);
        Symbol u=new SimpleAtomicSymbol("U", "Uracile", alph);
        Symbol c=new SimpleAtomicSymbol("C", "Cytosine", alph);
        Symbol g=new SimpleAtomicSymbol("G", "Guanine", alph);
        alph.addSymbol(a);
        alph.addSymbol(u);
        alph.addSymbol(c);
        alph.addSymbol(g);

        return alph;
    }

    private static Alphabet generateProteinAlphabet(){
        Alphabet alph=new SimpleAlphabet("Protein");
        Symbol a=new SimpleAtomicSymbol("A", "Ala", alph);
        Symbol r=new SimpleAtomicSymbol("R", "Arg", alph);
        Symbol n=new SimpleAtomicSymbol("N", "Asn", alph);
        Symbol d=new SimpleAtomicSymbol("D", "Asp", alph);

        Symbol c=new SimpleAtomicSymbol("C", "Cys", alph);
        Symbol q=new SimpleAtomicSymbol("Q", "Gln", alph);
        Symbol e=new SimpleAtomicSymbol("E", "Glu", alph);
        Symbol g=new SimpleAtomicSymbol("G", "Gly", alph);

        Symbol h=new SimpleAtomicSymbol("H", "His", alph);
        Symbol i=new SimpleAtomicSymbol("I", "Ile", alph);
        Symbol start=new SimpleAtomicSymbol("+", "Start", alph);
        Symbol l=new SimpleAtomicSymbol("L", "Leu", alph);

        Symbol k=new SimpleAtomicSymbol("K", "Lys", alph);
        Symbol m=new SimpleAtomicSymbol("M", "Met", alph);
        Symbol f=new SimpleAtomicSymbol("F", "Phe", alph);
        Symbol p=new SimpleAtomicSymbol("P", "Pro", alph);

        Symbol s=new SimpleAtomicSymbol("S", "Ser", alph);
        Symbol t=new SimpleAtomicSymbol("T", "Thr", alph);
        Symbol w=new SimpleAtomicSymbol("W", "Trp", alph);
        Symbol y=new SimpleAtomicSymbol("Y", "Tyr", alph);

        Symbol v=new SimpleAtomicSymbol("V", "Val", alph);
        Symbol z=new SimpleAtomicSymbol("*", "Stop", alph);

        alph.addSymbol(a);
        alph.addSymbol(r);
        alph.addSymbol(n);
        alph.addSymbol(d);

        alph.addSymbol(c);
        alph.addSymbol(q);
        alph.addSymbol(e);
        alph.addSymbol(g);

        alph.addSymbol(h);
        alph.addSymbol(i);
        alph.addSymbol(start);
        alph.addSymbol(l);

        alph.addSymbol(k);
        alph.addSymbol(m);
        alph.addSymbol(f);
        alph.addSymbol(p);

        alph.addSymbol(s);
        alph.addSymbol(t);
        alph.addSymbol(w);
        alph.addSymbol(y);

        alph.addSymbol(v);
        alph.addSymbol(z);

        return alph;
    }

    private static Alphabet generateCodonAlphabet(){
        Alphabet alph=new SimpleAlphabet("Codon");
        Symbol a=new SimpleAtomicSymbol("UUU", "", alph); alph.addSymbol(a);
        a=new SimpleAtomicSymbol("UUC", "", alph); alph.addSymbol(a);
        a=new SimpleAtomicSymbol("UUA", "", alph); alph.addSymbol(a);
        a=new SimpleAtomicSymbol("UUG", "", alph); alph.addSymbol(a);

        a=new SimpleAtomicSymbol("UCU", "", alph); alph.addSymbol(a);
        a=new SimpleAtomicSymbol("UCC", "", alph); alph.addSymbol(a);
        a=new SimpleAtomicSymbol("UCA", "", alph); alph.addSymbol(a);
        a=new SimpleAtomicSymbol("UCG", "", alph); alph.addSymbol(a);

        a=new SimpleAtomicSymbol("UAU", "", alph); alph.addSymbol(a);
        a=new SimpleAtomicSymbol("UAC", "", alph); alph.addSymbol(a);
        a=new SimpleAtomicSymbol("UAA", "", alph); alph.addSymbol(a);
        a=new SimpleAtomicSymbol("UCG", "", alph); alph.addSymbol(a);

        a=new SimpleAtomicSymbol("UGU", "", alph); alph.addSymbol(a);
        a=new SimpleAtomicSymbol("UGC", "", alph); alph.addSymbol(a);
        a=new SimpleAtomicSymbol("UGA", "", alph); alph.addSymbol(a);
        a=new SimpleAtomicSymbol("UGG", "", alph); alph.addSymbol(a);


        a=new SimpleAtomicSymbol("CUU", "", alph); alph.addSymbol(a);
        a=new SimpleAtomicSymbol("CUC", "", alph); alph.addSymbol(a);
        a=new SimpleAtomicSymbol("CUA", "", alph); alph.addSymbol(a);
        a=new SimpleAtomicSymbol("CUG", "", alph); alph.addSymbol(a);

        a=new SimpleAtomicSymbol("CCU", "", alph); alph.addSymbol(a);
        a=new SimpleAtomicSymbol("CCC", "", alph); alph.addSymbol(a);
        a=new SimpleAtomicSymbol("CCA", "", alph); alph.addSymbol(a);
        a=new SimpleAtomicSymbol("CCG", "", alph); alph.addSymbol(a);

        a=new SimpleAtomicSymbol("CAU", "", alph); alph.addSymbol(a);
        a=new SimpleAtomicSymbol("CAC", "", alph); alph.addSymbol(a);
        a=new SimpleAtomicSymbol("CAA", "", alph); alph.addSymbol(a);
        a=new SimpleAtomicSymbol("CCG", "", alph); alph.addSymbol(a);

        a=new SimpleAtomicSymbol("CGU", "", alph); alph.addSymbol(a);
        a=new SimpleAtomicSymbol("CGC", "", alph); alph.addSymbol(a);
        a=new SimpleAtomicSymbol("CGA", "", alph); alph.addSymbol(a);
        a=new SimpleAtomicSymbol("CGG", "", alph); alph.addSymbol(a);


        a=new SimpleAtomicSymbol("AUU", "", alph); alph.addSymbol(a);
        a=new SimpleAtomicSymbol("AUC", "", alph); alph.addSymbol(a);
        a=new SimpleAtomicSymbol("AUA", "", alph); alph.addSymbol(a);
        a=new SimpleAtomicSymbol("AUG", "", alph); alph.addSymbol(a);

        a=new SimpleAtomicSymbol("ACU", "", alph); alph.addSymbol(a);
        a=new SimpleAtomicSymbol("ACC", "", alph); alph.addSymbol(a);
        a=new SimpleAtomicSymbol("ACA", "", alph); alph.addSymbol(a);
        a=new SimpleAtomicSymbol("ACG", "", alph); alph.addSymbol(a);

        a=new SimpleAtomicSymbol("AAU", "", alph); alph.addSymbol(a);
        a=new SimpleAtomicSymbol("AAC", "", alph); alph.addSymbol(a);
        a=new SimpleAtomicSymbol("AAA", "", alph); alph.addSymbol(a);
        a=new SimpleAtomicSymbol("ACG", "", alph); alph.addSymbol(a);

        a=new SimpleAtomicSymbol("AGU", "", alph); alph.addSymbol(a);
        a=new SimpleAtomicSymbol("AGC", "", alph); alph.addSymbol(a);
        a=new SimpleAtomicSymbol("AGA", "", alph); alph.addSymbol(a);
        a=new SimpleAtomicSymbol("AGG", "", alph); alph.addSymbol(a);


        a=new SimpleAtomicSymbol("GUU", "", alph); alph.addSymbol(a);
        a=new SimpleAtomicSymbol("GUC", "", alph); alph.addSymbol(a);
        a=new SimpleAtomicSymbol("GUA", "", alph); alph.addSymbol(a);
        a=new SimpleAtomicSymbol("GUG", "", alph); alph.addSymbol(a);

        a=new SimpleAtomicSymbol("GCU", "", alph); alph.addSymbol(a);
        a=new SimpleAtomicSymbol("GCC", "", alph); alph.addSymbol(a);
        a=new SimpleAtomicSymbol("GCA", "", alph); alph.addSymbol(a);
        a=new SimpleAtomicSymbol("GCG", "", alph); alph.addSymbol(a);

        a=new SimpleAtomicSymbol("GAU", "", alph); alph.addSymbol(a);
        a=new SimpleAtomicSymbol("GAC", "", alph); alph.addSymbol(a);
        a=new SimpleAtomicSymbol("GAA", "", alph); alph.addSymbol(a);
        a=new SimpleAtomicSymbol("GCG", "", alph); alph.addSymbol(a);

        a=new SimpleAtomicSymbol("GGU", "", alph); alph.addSymbol(a);
        a=new SimpleAtomicSymbol("GGC", "", alph); alph.addSymbol(a);
        a=new SimpleAtomicSymbol("GGA", "", alph); alph.addSymbol(a);
        a=new SimpleAtomicSymbol("GGG", "", alph); alph.addSymbol(a);

        return alph;
    }


}
