/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package bioinformatics1;

import java.util.Iterator;

/**
 *
 * @author caste
 */
public class ProteinTools {
    private static Alphabet alphProtein=AlphabetManager.alphabetForName("Protein");    // Protein alphabet


    /**
     * Generates a sequence of pointers to Symbols from a String
     */
    public static Sequence createProteinSequence(String protein, String name) throws Exception {
        Sequence seq=new SimpleSequence(name);  // Empty sequence

        seq.setAlphabet(alphProtein);
        for(int i=0; i<protein.length(); i++){
            if(protein.charAt(i)=='A')
                seq.add(a());
            if(protein.charAt(i)=='R')
                seq.add(r());
            if(protein.charAt(i)=='N')
                seq.add(n());
            if(protein.charAt(i)=='D')
                seq.add(d());
            if(protein.charAt(i)=='C')
                seq.add(c());
            if(protein.charAt(i)=='Q')
                seq.add(q());
            if(protein.charAt(i)=='E')
                seq.add(e());
            if(protein.charAt(i)=='G')
                seq.add(g());
            if(protein.charAt(i)=='H')
                seq.add(h());
            if(protein.charAt(i)=='I')
                seq.add(i());
            if(protein.charAt(i)=='+')
                seq.add(start());
            if(protein.charAt(i)=='L')
                seq.add(l());
            if(protein.charAt(i)=='K')
                seq.add(k());
            if(protein.charAt(i)=='M')
                seq.add(m());
            if(protein.charAt(i)=='F')
                seq.add(f());
            if(protein.charAt(i)=='P')
                seq.add(p());
            if(protein.charAt(i)=='S')
                seq.add(s());
            if(protein.charAt(i)=='T')
                seq.add(t());
            if(protein.charAt(i)=='W')
                seq.add(w());
            if(protein.charAt(i)=='Y')
                seq.add(y());
            if(protein.charAt(i)=='V')
                seq.add(v());
            if(protein.charAt(i)=='*')
                seq.add(stop());

        }
        return seq;
    }

    public static SymbolList createProteinSymbolList(String dna) {
        SymbolList list=null;
        // To be implemented
        return list;
    }

    /**
     * Returns symbol for adenine
     */
    public static Symbol a() {
        Iterator it=alphProtein.iterator();
        while(it.hasNext()){
            Symbol s1=(Symbol)it.next();
            if(s1.getName().equals("A")){
                return s1;
            }
        }
        return null;
    }

    public static Symbol r() {
        Iterator it=alphProtein.iterator();
        while(it.hasNext()){
            Symbol s1=(Symbol)it.next();
            if(s1.getName().equals("R")){
                return s1;
            }
        }
        return null;
    }

    public static Symbol n() {
        Iterator it=alphProtein.iterator();
        while(it.hasNext()){
            Symbol s1=(Symbol)it.next();
            if(s1.getName().equals("N")){
                return s1;
            }
        }
        return null;
    }

    public static Symbol d() {
        Iterator it=alphProtein.iterator();
        while(it.hasNext()){
            Symbol s1=(Symbol)it.next();
            if(s1.getName().equals("D")){
                return s1;
            }
        }
        return null;
    }

    public static Symbol c() {
        Iterator it=alphProtein.iterator();
        while(it.hasNext()){
            Symbol s1=(Symbol)it.next();
            if(s1.getName().equals("C")){
                return s1;
            }
        }
        return null;
    }

    public static Symbol q() {
        Iterator it=alphProtein.iterator();
        while(it.hasNext()){
            Symbol s1=(Symbol)it.next();
            if(s1.getName().equals("Q")){
                return s1;
            }
        }
        return null;
    }

    public static Symbol e() {
        Iterator it=alphProtein.iterator();
        while(it.hasNext()){
            Symbol s1=(Symbol)it.next();
            if(s1.getName().equals("E")){
                return s1;
            }
        }
        return null;
    }

    public static Symbol g() {
        Iterator it=alphProtein.iterator();
        while(it.hasNext()){
            Symbol s1=(Symbol)it.next();
            if(s1.getName().equals("G")){
                return s1;
            }
        }
        return null;
    }

    public static Symbol h() {
        Iterator it=alphProtein.iterator();
        while(it.hasNext()){
            Symbol s1=(Symbol)it.next();
            if(s1.getName().equals("H")){
                return s1;
            }
        }
        return null;
    }

    public static Symbol i() {
        Iterator it=alphProtein.iterator();
        while(it.hasNext()){
            Symbol s1=(Symbol)it.next();
            if(s1.getName().equals("I")){
                return s1;
            }
        }
        return null;
    }

    public static Symbol start() {
        Iterator it=alphProtein.iterator();
        while(it.hasNext()){
            Symbol s1=(Symbol)it.next();
            if(s1.getName().equals("+")){
                return s1;
            }
        }
        return null;
    }

    public static Symbol l() {
        Iterator it=alphProtein.iterator();
        while(it.hasNext()){
            Symbol s1=(Symbol)it.next();
            if(s1.getName().equals("L")){
                return s1;
            }
        }
        return null;
    }

    public static Symbol k() {
        Iterator it=alphProtein.iterator();
        while(it.hasNext()){
            Symbol s1=(Symbol)it.next();
            if(s1.getName().equals("K")){
                return s1;
            }
        }
        return null;
    }

    public static Symbol m() {
        Iterator it=alphProtein.iterator();
        while(it.hasNext()){
            Symbol s1=(Symbol)it.next();
            if(s1.getName().equals("M")){
                return s1;
            }
        }
        return null;
    }

    public static Symbol f() {
        Iterator it=alphProtein.iterator();
        while(it.hasNext()){
            Symbol s1=(Symbol)it.next();
            if(s1.getName().equals("F")){
                return s1;
            }
        }
        return null;
    }

    public static Symbol p() {
        Iterator it=alphProtein.iterator();
        while(it.hasNext()){
            Symbol s1=(Symbol)it.next();
            if(s1.getName().equals("P")){
                return s1;
            }
        }
        return null;
    }

    public static Symbol s() {
        Iterator it=alphProtein.iterator();
        while(it.hasNext()){
            Symbol s1=(Symbol)it.next();
            if(s1.getName().equals("S")){
                return s1;
            }
        }
        return null;
    }

    public static Symbol t() {
        Iterator it=alphProtein.iterator();
        while(it.hasNext()){
            Symbol s1=(Symbol)it.next();
            if(s1.getName().equals("T")){
                return s1;
            }
        }
        return null;
    }

    public static Symbol w() {
        Iterator it=alphProtein.iterator();
        while(it.hasNext()){
            Symbol s1=(Symbol)it.next();
            if(s1.getName().equals("W")){
                return s1;
            }
        }
        return null;
    }

    public static Symbol y() {
        Iterator it=alphProtein.iterator();
        while(it.hasNext()){
            Symbol s1=(Symbol)it.next();
            if(s1.getName().equals("Y")){
                return s1;
            }
        }
        return null;
    }

    public static Symbol v() {
        Iterator it=alphProtein.iterator();
        while(it.hasNext()){
            Symbol s1=(Symbol)it.next();
            if(s1.getName().equals("V")){
                return s1;
            }
        }
        return null;
    }

    public static Symbol stop() {
        Iterator it=alphProtein.iterator();
        while(it.hasNext()){
            Symbol s1=(Symbol)it.next();
            if(s1.getName().equals("*")){
                return s1;
            }
        }
        return null;
    }








}
