/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package bioinformatics1;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

/**
 *
 * @author caste
 */

/**
 * A basic implementation of the Sequence interface.
 */
public class SimpleSequence implements Sequence {
    private List<Symbol> list;
    private Alphabet alphabet;
    private String name;

    public SimpleSequence(String seqName){
        list=new ArrayList();
        name=seqName;
    }

    public SimpleSequence(ArrayList l, String seqName){
        list=l;
        name=seqName;
    }

    /**
     * @return the list
     */
    public List<Symbol> getList() {
        return list;
    }

    /**
     * @param list the list to set
     */
    public void setList(List<Symbol> list) {
        this.list = list;
    }

    /**
     * @return the alphabet
     */
    public Alphabet getAlphabet() {
        return alphabet;
    }

    /**
     * @param alphabet the alphabet to set
     */
    public void setAlphabet(Alphabet alphabet) {
        this.alphabet = alphabet;
    }

    public int length() {
        return list.size();
    }

    public Iterator<Symbol> iterator(){
        return list.iterator();
    }

    public String seqString(){
        return list.toString();
    }

    public String subStr(int start, int end){
        return list.toString().substring(start, end);
    }

    public Symbol symbolAt(int index){
        return list.get(index);
    }

    public void add(Symbol s){
        list.add(s);
    }

    public String getName() {
        return name;
    }

    /**
     * @param name the name to set
     */
    public void setName(String name) {
        this.name = name;
    }

    public void printSequenceDescriptions(){
        System.out.println("Sequence: "+name);
        System.out.println("Sequence length: "+length());
        for(Symbol s:list) {
            System.out.println(s.getName()+" - "+s.getDescription());
        }
    }
}
